*** applications/aufs/afpdt.c.orig	Wed Sep 25 00:10:20 1996
--- applications/aufs/afpdt.c		Mon Jul  7 17:01:14 1997
***************
*** 1170,1176 ****
      PrintIconInfo(adi.adi_fcreator,adi.adi_ftype);
    }
  
!   err = SPWrtContinue(cno,reqref,icon,adi.adi_iconsize,&rcvlen,-1,&comp);
    if (err != noErr) {
      free((char *)icon);
      return(err);
--- 1170,1176 ----
      PrintIconInfo(adi.adi_fcreator,adi.adi_ftype);
    }
  
!   err = dsiWrtContinue(cno,reqref,icon,adi.adi_iconsize,&rcvlen,-1,&comp);
    if (err != noErr) {
      free((char *)icon);
      return(err);
*** applications/aufs/afpfork.c.orig	Wed Sep 25 00:09:33 1996
--- applications/aufs/afpfork.c		Mon Jul  7 17:43:35 1997
***************
*** 585,591 ****
        return(aeAccessDenied);
    }
  
!   err = SPWrtContinue(cno,reqref,r,n_rrpkts*atpMaxData,&rcvlen,-1,&comp);
    if (err != noErr)
      return(err);
    do { abSleep(4,TRUE); } while (comp > 0);    
--- 585,591 ----
        return(aeAccessDenied);
    }
  
!   err = dsiWrtContinue(cno,reqref,r,n_rrpkts*atpMaxData,&rcvlen,-1,&comp);
    if (err != noErr)
      return(err);
    do { abSleep(4,TRUE); } while (comp > 0);    
*** applications/aufs/afpos.c.orig	Wed Sep 25 00:10:24 1996
--- applications/aufs/afpos.c		Wed Jul  9 11:39:02 1997
***************
*** 766,772 ****
--- 766,776 ----
  	  msg[i] = '\r';
      }
      close(fd);
+     return(noErr);
    }
+ 
+   sprintf(msg, "<no path to message file>");
+ 
    return(noErr);
  }
  
*** applications/aufs/afps.h.orig	Wed Sep 25 00:10:19 1996
--- applications/aufs/afps.h		Mon Mar  3 22:14:05 1997
***************
*** 247,252 ****
--- 247,253 ----
  #define AFPVersion1DOT1 110
  #define AFPVersion2DOT0 200
  #define AFPVersion2DOT1 210
+ #define AFPVersion2DOT2 220
  
  #ifdef APPLICATION_MANAGER
  struct flist {
*** applications/aufs/afpserver.c.orig	Wed Sep 25 00:10:23 1996
--- applications/aufs/afpserver.c	Wed Jul  9 10:44:28 1997
***************
*** 47,52 ****
--- 47,54 ----
   /* assume included by param.h */
  # include <sys/types.h>
  #endif
+ #include <sys/socket.h>
+ #include <netdb.h>
  #include <sys/time.h>
  #include <sys/resource.h>
  #include <netat/appletalk.h>
***************
*** 97,103 ****
  
  private char *afpmtyp = "Unix";
  
! #define AFPVERSZ (5*16)			/* room for IndStr hold all versions */
  /* define 1 more than needed just in case */
  struct afpversionstruct {
    char *version_name;
--- 99,105 ----
  
  private char *afpmtyp = "Unix";
  
! #define AFPVERSZ (6*16)			/* room for IndStr hold all versions */
  /* define 1 more than needed just in case */
  struct afpversionstruct {
    char *version_name;
***************
*** 107,112 ****
--- 109,115 ----
    {"AFPVersion 1.1", AFPVersion1DOT1},
    {"AFPVersion 2.0", AFPVersion2DOT0},
    {"AFPVersion 2.1", AFPVersion2DOT1},
+   {"AFP2.2", AFPVersion2DOT2},
    {NULL, AFPVersionUnknown}
  };
  
***************
*** 216,221 ****
--- 219,229 ----
  
  private DumpBuf(), clockstart(), clockend();
  
+ private struct sig {
+   byte filler[8];
+   struct timeval s_time;
+ } sig;
+ 
  #ifdef LOGIN_AUTH_PROG
  extern char *srvrname;		/* NBP registered name of server */
  extern char *login_auth_prog;	/* name of authorization program */
***************
*** 254,259 ****
--- 262,271 ----
  #ifdef STAT_CACHE
    OSStatInit();			/* init stat cache */
  #endif STAT_CACHE
+ 
+   /* init server signature */
+   bzero((char *)&sig, sizeof(struct sig));
+   gettimeofday(&sig.s_time, NULL);
  }
  
  /*
***************
*** 968,974 ****
      fprintf(dbg, "\tMsgTyp: %04x\t", smrp.msgr_typ);
      fprintf(dbg, "(%s)\n", (smrp.msgr_typ == 0) ? "Login" : "Server");
      fprintf(dbg, "\tMsgBMp: %04x\n", smrp.msgr_bitmap);
!     dbg_print_name("\tMsgStr:", smrp.msgr_data);
      fflush(dbg);
    }
  #endif /* DEBUG_AFP_CMD */
--- 980,986 ----
      fprintf(dbg, "\tMsgTyp: %04x\t", smrp.msgr_typ);
      fprintf(dbg, "(%s)\n", (smrp.msgr_typ == 0) ? "Login" : "Server");
      fprintf(dbg, "\tMsgBMp: %04x\n", smrp.msgr_bitmap);
!     fprintf(dbg, "\tMsgStr: %s\n", smrp.msgr_data);
      fflush(dbg);
    }
  #endif /* DEBUG_AFP_CMD */
***************
*** 1035,1040 ****
--- 1047,1055 ----
  }
  #endif
  
+ #define MAXNADSIZ	8		/* tag #2, IP addr & port */
+ #define NUMNAD		5		/* no more than 5 IP addr/host */
+ 
  int 
  GetSrvrInfo(r,sname,icon,iconsize)
  byte *r;
***************
*** 1042,1068 ****
  byte icon[];
  int iconsize;
  {
    int i,len;
    extern int nopwdsave;
    GetSrvrInfoReplyPkt sr;
    byte avobuf[AFPVERSZ],uamobuf[AFPUAMSZ];
!   OPTRType avo,uamo,vicono;
  
!   strcpy(sr.sr_machtype,afpmtyp);
!   cpyc2pstr(sr.sr_servername,sname);
!   /* set server capabilities */
    sr.sr_flags = SupportsFPCopyFile;
  #ifdef DISTRIB_PASSWDS
    sr.sr_flags |= SupportsChgPwd;
  #endif DISTRIB_PASSWDS
    sr.sr_flags |= SupportsServerMsgs;
    if (nopwdsave)
      sr.sr_flags |= DontAllowSavePwd;
  
    vicono.optr_loc = icon;
    vicono.optr_len = iconsize;
    sr.sr_vicono = (char *) &vicono;
  
    IniIndStr(avobuf);
    for (i = 0; afpversions[i].version_name != NULL; i++)
      AddIndStr(afpversions[i].version_name, avobuf);
--- 1057,1109 ----
  byte icon[];
  int iconsize;
  {
+   byte *q;
    int i,len;
    extern int nopwdsave;
    GetSrvrInfoReplyPkt sr;
+   OPTRType avo,uamo,vicono,sigo,nado;
    byte avobuf[AFPVERSZ],uamobuf[AFPUAMSZ];
!   byte nadbuf[MAXNADSIZ*NUMNAD+1];
!   extern u_short asip_port;
!   extern u_int asip_addr;
!   extern int asip_enable;
!   struct hostent *he;
!   char hostname[128];
  
!   /*
!    * set server capabilities
!    *
!    */
    sr.sr_flags = SupportsFPCopyFile;
  #ifdef DISTRIB_PASSWDS
    sr.sr_flags |= SupportsChgPwd;
  #endif DISTRIB_PASSWDS
    sr.sr_flags |= SupportsServerMsgs;
+   sr.sr_flags |= SupportsServerSig;
+   if (asip_enable)
+     sr.sr_flags |= SupportsTCPIP;
    if (nopwdsave)
      sr.sr_flags |= DontAllowSavePwd;
  
+   /*
+    * set Server Name & Machine Type
+    *
+    */
+   strcpy(sr.sr_machtype,afpmtyp);
+   cpyc2pstr(sr.sr_servername,sname);
+ 
+   /*
+    * set Volume Icon & Mask
+    *
+    */
    vicono.optr_loc = icon;
    vicono.optr_len = iconsize;
    sr.sr_vicono = (char *) &vicono;
  
+   /*
+    * set AFP Versions
+    *
+    */
    IniIndStr(avobuf);
    for (i = 0; afpversions[i].version_name != NULL; i++)
      AddIndStr(afpversions[i].version_name, avobuf);
***************
*** 1070,1075 ****
--- 1111,1120 ----
    avo.optr_loc = avobuf;
    sr.sr_avo = (byte *) &avo;
  
+   /*
+    * set UAMs
+    *
+    */
    IniIndStr(uamobuf);
    for (i=0 ; i < numuam; i++)
      AddIndStr(afpuams[i].uamname, uamobuf);
***************
*** 1077,1082 ****
--- 1122,1191 ----
    uamo.optr_loc = uamobuf;
    sr.sr_uamo = (byte *) &uamo;
  
+   /*
+    * set server signature
+    *
+    */
+   sigo.optr_len = 16;
+   sigo.optr_loc = (byte *)&sig;
+   sr.sr_sigo = (byte *)&sigo;
+ 
+   /*
+    * set network address(es)
+    * use single bound address (-B <addr:port>)
+    * or all known addresses for this machine
+    *
+    */
+   q = nadbuf+1;
+   nadbuf[0] = 0;
+   if (asip_enable) {
+     if (asip_addr) {
+       nadbuf[0] = 1;
+       q[2] = (asip_addr >> 24) & 0xff;
+       q[3] = (asip_addr >> 16) & 0xff;
+       q[4] = (asip_addr >>  8) & 0xff;
+       q[5] = (asip_addr & 0xff);
+       if (asip_port == ASIP_PORT) {
+         q[0] = 0x06; /* len */
+         q[1] = 0x01; /* tag */
+         q += 6;
+       } else {
+         q[0] = 0x08; /* len */
+         q[1] = 0x02; /* tag */
+         q[6] = asip_port >> 8;
+         q[7] = asip_port & 0xff;
+         q += 8;
+       }
+     } else { /* list all known addresses */
+       if (gethostname(hostname, sizeof(hostname)) == 0) {
+         if ((he = gethostbyname(hostname)) != NULL) {
+           for (i = 0; he->h_addr_list[i] && i < NUMNAD; i++) {
+ 	    bcopy(he->h_addr_list[i], q+2, 4); /* copy IP */
+ 	    if (asip_port == ASIP_PORT) {
+ 	      q[0] = 0x06; /* len */
+ 	      q[1] = 0x01; /* tag */
+ 	      q += 6;
+ 	    } else {
+ 	      q[0] = 0x08; /* len */
+ 	      q[1] = 0x02; /* tag */
+ 	      q[6] = asip_port >> 8;
+ 	      q[7] = asip_port & 0xff;
+ 	      q += 8;
+ 	    }
+           }
+           nadbuf[0] = i;
+         }
+       }
+     }
+   }
+   nado.optr_len = q-nadbuf;
+   nado.optr_loc = nadbuf;
+   sr.sr_naddro = (byte *)&nado;
+ 
+   /*
+    * pack data for sending
+    *
+    */
    len = htonPackX(ProtoSRP,(byte *) &sr,r);
  
  #ifdef DEBUG_AFP_CMD
***************
*** 1389,1395 ****
    int i;
    byte *q = r;
    u_short srvrflags;
!   short machoff, afpoff, uamoff, vicnoff;
    void dbg_print_name();
    void dbg_print_sflg();
    void dbg_print_icon();
--- 1498,1505 ----
    int i;
    byte *q = r;
    u_short srvrflags;
!   short machoff, afpoff, uamoff;
!   short vicnoff, sigoff, nadoff;
    void dbg_print_name();
    void dbg_print_sflg();
    void dbg_print_icon();
***************
*** 1402,1410 ****
    fprintf(dbg, "\tUAMOff: %d\n", uamoff);
    vicnoff = get2(q); q += 2;
    fprintf(dbg, "\tICNOff: %d\n", vicnoff);
!   fprintf(dbg, "\tVolFlg: %04x\t", (srvrflags = get2(q))); q += 2;
    dbg_print_sflg(srvrflags);
    dbg_print_name("\tSrvrNm:", q);
    if (machoff != 0)
      dbg_print_name("\tMchTyp:", r+machoff);
    if (afpoff != 0) {
--- 1512,1528 ----
    fprintf(dbg, "\tUAMOff: %d\n", uamoff);
    vicnoff = get2(q); q += 2;
    fprintf(dbg, "\tICNOff: %d\n", vicnoff);
!   srvrflags = get2(q); q += 2;
!   fprintf(dbg, "\tVolFlg: %04x\t", srvrflags);
    dbg_print_sflg(srvrflags);
    dbg_print_name("\tSrvrNm:", q);
+   q += ((*q)+1);
+   if ((u_long)q & 0x01)
+     q++; /* even */
+   sigoff = get2(q); q += 2;
+   fprintf(dbg, "\tSIGOff: %d\n", sigoff);
+   nadoff = get2(q); q += 2;
+   fprintf(dbg, "\tNADOff: %d\n", nadoff);
    if (machoff != 0)
      dbg_print_name("\tMchTyp:", r+machoff);
    if (afpoff != 0) {
***************
*** 1412,1418 ****
      fprintf(dbg, "\tVerCnt: %d\n", (int)(*q));
      for (i = *q++; i > 0; i--) {
        dbg_print_name("\tAFPVer:", q);
! 	q += ((*q) + 1);
      }
    } else
      fprintf(dbg, "\t<no AFP>\n");
--- 1530,1536 ----
      fprintf(dbg, "\tVerCnt: %d\n", (int)(*q));
      for (i = *q++; i > 0; i--) {
        dbg_print_name("\tAFPVer:", q);
!       q += ((*q) + 1);
      }
    } else
      fprintf(dbg, "\t<no AFP>\n");
***************
*** 1431,1436 ****
--- 1549,1588 ----
      fprintf(dbg, "\n");
    } else
      fprintf(dbg, "\t<no ICON>\n");
+   if (sigoff != 0) {
+     q = r + sigoff;
+     fprintf(dbg, "\tSrvSIG: ");
+     for (i = 0; i < 16; i++)
+       fprintf(dbg, "%02x ", *(q+i));
+     fprintf(dbg, "\n");
+   } else
+     fprintf(dbg, "\t<no SIG>\n");
+   if (nadoff != 0) {
+     q = r + nadoff;
+     fprintf(dbg, "\tNADCnt: %d\n", (int)(*q));
+     for (i = *q++; i > 0; i--) {
+       fprintf(dbg, "\tAFPNAD: len %d tag %d ", q[0], q[1]);
+       switch (q[1]) {
+ 	case 0x01:
+ 	  fprintf(dbg, "IP %d.%d.%d.%d\n",
+ 	    q[2], q[3], q[4], q[5]);
+ 	  break;
+ 	case 0x02:
+ 	  fprintf(dbg, "IP %d.%d.%d.%d Port %d\n",
+ 	    q[2], q[3], q[4], q[5], (q[6] << 8) | q[7]);
+ 	  break;
+ 	case 0x03:
+ 	  fprintf(dbg, "DDP net %d.%d node %d skt %d\n",
+ 	    q[2], q[3], q[4], q[5]);
+ 	  break;
+ 	default:
+ 	  fprintf(dbg, "<unknown>\n");
+ 	  break;
+       }
+       q += q[0];
+     }
+   } else
+     fprintf(dbg, "\t<no NAD>\n");
  
    return;
  }
***************
*** 1475,1485 ****
  	bmap &= ~(0x0001 << i);
  	switch (i) {
  	  case 0:
! 	    fprintf(dbg, "SuppCopyFile");
  	    j++;
  	    break;
  	  case 1:
! 	    fprintf(dbg, "SuppChngPass");
  	    j++;
              break;
  	  case 2:
--- 1627,1637 ----
  	bmap &= ~(0x0001 << i);
  	switch (i) {
  	  case 0:
! 	    fprintf(dbg, "CopyFile");
  	    j++;
  	    break;
  	  case 1:
! 	    fprintf(dbg, "ChngPass");
  	    j++;
              break;
  	  case 2:
***************
*** 1487,1497 ****
  	    j++;
  	    break;
  	  case 3:
! 	    fprintf(dbg, "SuppSrvrMesg");
  	    j++;
  	    break;
  	  case 15:
! 	    fprintf(dbg, "SuppMGetReqs");
  	    j++;
  	    break;
  	  default:
--- 1639,1661 ----
  	    j++;
  	    break;
  	  case 3:
! 	    fprintf(dbg, "SrvrMesg");
! 	    j++;
! 	    break;
! 	  case 4:
! 	    fprintf(dbg, "SrvrSig");
! 	    j++;
! 	    break;
! 	  case 5:
! 	    fprintf(dbg, "TCP/IP");
! 	    j++;
! 	    break;
! 	  case 6:
! 	    fprintf(dbg, "SrvrNotf");
  	    j++;
  	    break;
  	  case 15:
! 	    fprintf(dbg, "MGetReqs");
  	    j++;
  	    break;
  	  default:
